package com.model;

import java.io.File;
import com.util.FileUtils;


public class Profile extends KeyTitleDefault {

  private String developerName;
  private String publisherName;
  private String genre;
  private String year;
  private int dbversionId;
  private String setup;
  private String setupParams;
  private String notes;
  private String[] link;
  private String status;
  private String confPathAndFile;
  private String captures;
  private String[] customString;
  private int[] customInt;
  
  
  public Profile(int id, String title, String devName, String publName, String genre, String year, int dbversionId,
  		String setup, String setupParams, String notes, String link1, String link2, boolean favorite, String status,
  		String confPathAndFile, String captures, String link3, String link4, 
  		String c1, String c2, String c3, String c4, String c5, String c6, String c7, String c8, int c9, int c10) {
  	super(id, title, favorite);
    this.developerName = devName;
    this.publisherName = publName;
    this.genre = genre;
    this.year = year;
    this.dbversionId = dbversionId;
    this.setup = setup;
    this.setupParams = setupParams;
    this.notes = notes;
    this.status = status;
    this.confPathAndFile = confPathAndFile;
    this.captures = captures;
    this.link = new String[] {link1, link2, link3, link4};
    this.customString = new String[] {c1, c2, c3, c4, c5, c6, c7, c8};
    this.customInt = new int[] {c9, c10};
  }
  
  public Profile(int id, String confFile, String captures, Profile prof) {
  	this(id, prof.getTitle(), prof.getDeveloperName(),
    		prof.getPublisherName(), prof.getGenre(), prof.getYear(), prof.getDbversionId(),
    		prof.getSetup(), prof.getSetupParameters(), prof.getNotes(), prof.getLink(0),
    		prof.getLink(1), prof.isDefault(), prof.getStatus(), confFile, captures,
    		prof.getLink(2), prof.getLink(3), prof.getCustomString(0), prof.getCustomString(1),
    		prof.getCustomString(2), prof.getCustomString(3), prof.getCustomString(4), 
    		prof.getCustomString(5), prof.getCustomString(6), prof.getCustomString(7),
        prof.getCustomInt(0), prof.getCustomInt(1));
  }

  public String getDeveloperName() {
    return developerName;
  }

  public String getGenre() {
    return genre;
  }

  public String getPublisherName() {
    return publisherName;
  }

  public String getYear() {
    return year;
  }

  public int getDbversionId() {
    return dbversionId;
  }

  public boolean hasSetup() {
    return !setup.equals("");
  }

  public String hasSetupString() {
    return hasSetup()? "Yes": "No";
  }

  public String[] getLinks() {
    return link;
  }
  
  public String getLink(int i) {
    return link[i];
  }

  public String getNotes() {
    return notes;
  }

  public String getSetup() {
    return setup;
  }

  public String getSetupParameters() {
    return setupParams;
  }

  public String getStatus() {
    return status;
  }
  
	public String getConfPathAndFile() {
		return confPathAndFile;
	}
	
	public File getCanonicalConfFile() {
		return FileUtils.canonicalToData(confPathAndFile);
	}

	public String getCaptures() {
		return captures;
	}
	
	public File getCanonicalCaptures() {
		return FileUtils.canonicalToData(captures);
	}
  
  public String getCustomString(int i) {
  	return customString[i];
  }
  
  public int getCustomInt(int i) {
  	return customInt[i];
  }
}
